import java.io.FileInputStream;
import java.io.InputStream;
import java.net.NetworkInterface;
import java.util.Enumeration;
import java.util.Properties;
import java.util.Scanner;
import hpdos.protocol.AckType;

public class StandaloneRDMAClient {
    //Donot delete this line
    //Used to find which core process is using
    //while true; do echo -ne "`ps -o pid,psr,comm -p <pid>`"; done
    
        public static void main(String[] args) throws Exception {
            Scanner scanner = new Scanner(System.in);
            System.out.println("Enter Invalidation  Server IP to bind");
            Properties properties= new Properties();
            InputStream inputStream = new FileInputStream(args[0]);
            properties.load(inputStream);
            
           // String address = scanner.nextLine();
            
            MetadataClient client = new MetadataClient(properties);
            
            int option;
            while (true) {
                System.out.println("Enter 1. for read and 2 for write 3 for delete: ");
                option = scanner.nextInt();
                if(option == 1)
                {
                    System.out.println("Enter key: ");
                    String inputkey = scanner.next();
                    byte[] key = new byte[128];
                    for(int i=0;i<inputkey.length();i++)
                    {
                        key[i]  = (byte)inputkey.charAt(i);   
                    }

                   byte[] value =  client.networkHandler.get(key);
                   
                   System.out.println("Got Response ");
                   if(value != null)
                       System.out.println(new String(value));
                }
                else if(option == 2)
                {
                    System.out.println("Enter key: ");
                    String inputkey = scanner.next();
                    System.out.println("Enter value: ");
                    String inputvalue = scanner.next();
                    byte[] key = new byte[128];
                    byte[] value = new byte[128];
                    for(int i=0;i<inputkey.length();i++)
                    {
                        key[i]  = (byte)inputkey.charAt(i);   
                    }

                    for(int i=0;i<inputvalue.length();i++)
                    {
                        value[i]  = (byte)inputvalue.charAt(i);   
                    }
                    int ack = client.networkHandler.put(key, value);
                    System.out.println("Response got Ack " +ack);
                    if (ack == AckType.SUCCESS) {
                        System.out.println("Success");
                    }
                       
                }else if(option == 3)
                {
                    System.out.println("Enter key: ");
                    String inputkey = scanner.next();
                    byte[] key = new byte[128];
                    for(int i=0;i<inputkey.length();i++)
                    {
                        key[i]  = (byte)inputkey.charAt(i);   
                    }
                    int ack = client.networkHandler.delete(key);
                    System.out.println("Response  got Ack " +ack);
                    if (ack == AckType.SUCCESS) {
                        System.out.println("Success");
                    }
                       
                }
                else
                {
                    System.out.println("Invalid option try again");
                    continue;
                }
                /*Stopwatch stopwatch = Stopwatch.createUnstarted();
                stopwatch.start(); 
                stopwatch.stop();
                long micros = stopwatch.elapsed(TimeUnit.MICROSECONDS);
                 System.out.println("Request took: "+micros+" microseconds.");
                */
            }  
            
            
        }
}
